
function GetRandom(len){
	var M = Math.pow(10,len) - 1;
	r = Math.ceil(Math.random()*M);
	var gaplen = len - (r+"").length;
	if(gaplen>0)
	{
		r = M - r;
	}
	return r + "";
}

function GetTradeNo(){
	var td = (new Date).getTime()+GetRandom(10);
	return td.toUpperCase();
}

function md5Twice(str){
	//console.log("MD:",md5(str),md5(md5(str)));
	return md5(md5(str));
}

//////////// 以下是真正数据接口部分 //////////////////////////////////////////////////
;(function($){
//执行命令
var aj;
$.aj = aj = function (apiname,inputModule,okfunc,errfunc){
	if(typeof api != "undefined")
		$.pa.setApiProxy(APIHOST);
	var opts = {url:"/action",input:inputModule};
	function okf(ret){
		if(ret && ret.result){
			if(okfunc)okfunc(ret);
		}
		else{
			if(errfunc)errfunc(ret);
		}
	}
	opts.success = okf;
	opts.error = errfunc;
	//$.pa.inject(apiname,opts);
	//console.log("POST:",apiname,opts);
	$.pa.execute(apiname,opts);
}

$.apiNotice = function(){
	aj("SERVER_NOTICE",{"action":"openapp"});
}

$.apiSwitchArea = function(areacode){
	var u = $api.getStorage('user')||{};
	areacode = areacode || u.areacode || 0;
	aj("SERVER_SWITCHAREA",{"action":"switcharea","areacode":areacode,"USER":u.userid});
}

function getSeq(){
	var sq = (new Date()).getTime();
	sq = sq + Math.ceil(Math.random()*999);
	return sq;
}

function makepostdata(op,model,condition,updater){
	var b = {};
	var u = $api.getStorage('user')||{};
	b.USER = u.userid || "";
	b.areacode = u.areacode || 0;
	b.action = op || "query";
	b.model = model || "";
	b.condition = condition;
	b.data = updater || "";
	b.seq = getSeq();
	return b;
}

function commNetErrFunc(errf){
	return function(err){
		var msg = (err&&err.msg)||"执行失败,网络系统故障";
		if(errf){
			errf({msg:msg});
		}
		else{
			alert(msg);
		}
		console.log("NETERR:"+JSON.stringify(err));
	}
}

function commSuccessFunc(okf,errf){
	return function(ret){
		ret = ret || {};
		//console.log(ret);
		if(ret.result){
			if(okf) okf(ret.data);
		}
		else{
			var msg = ret.msg || "执行失败,数据库错误";
			if(errf) errf({msg:msg});
		}
	}
}

function getId(){
	return Math.ceil(1000+Math.random()*999)
}

function makeShowTime(atr){
	return 'to_char('+atr+', \'YYYY-MM-DD HH24:MI:SS\') as '+atr;
}

function getNowTime(){
	return (new Date).format("yyyy-MM-dd hh:mm:ss");
}

function sqlstr(str){
	if(!str)return str;
	str = str.replace(/'/g,"''");
	return str;
}

$.apiUpload = function(filetype,content,okf,errf){
	var opts = {success:okf,error:errf,timout:30000,url:"/pic"};
	opts.input = {ext:filetype,pic:content};
	$.pa.execute("UPLOAD_"+getSeq(),opts);
}

function apiGetBase64PicExt(str){
	str = str.match(/\/\w{3,}\;/)+"";
	str = str.substr(1,str.length-2);
	return str;
}

$.apiUseProgressBar = useProgressBar = function(precent){
	precent = Math.min(precent,100);
	var pdom = $("#PROBAR").html();
	if(!pdom){
		var h = '<div id="PROBAR" class="ui-progress" style="position: fixed;bottom: 0;z-index: 9999;height: 4px;"> \
	            <span style="background:#FF6666"></span> \
	        </div>';
	    $('body').append(h);
	}
	if(precent >= 100){
		$('#PROBAR span').animate({width:"100%"},100,'linear');
		setTimeout(function(){$("#PROBAR").remove()},1000);
	}
	else
		$('#PROBAR span').animate({width:(precent-1)+"%"},1200,'linear');
}

$.apiUploadFileList = function(pics,cmf,prof){
	if(!pics || pics.length==0){
		if(cmf) cmf([]);
		if(prof) prof(100);
		return;
	}
	var size = pics.length;
	var plist = [];
	var isEnd = false;
	var urls = [];
	function loopCheck(){
		if(isEnd) return;
		var finishednum = 0;
		var len = plist.length;
		for(var i=0; i < len;i++){
			var po = plist[i];
			if(po.finished){
				finishednum++;
				urls[po.index] = po.url;
				console.log("INDEX:",po.index,po.url,urls.length);
			}
			var pcnt = (finishednum/(len-1))*100
			if(prof)
				prof(pcnt);
			if(finishednum == len)
			{
				if(cmf) cmf(urls);
				if(prof) prof(100);
				isEnd = true;
			}
		}
	}
	for(var i=0; i < size;i++){
		var po = new Object();
		po.content = pics[i];
		po.ext = apiGetBase64PicExt(po.content);
		po.index = i;
		function mkf(obj){
			return function(ret){
				obj.finished = true;
				if(ret && ret.url)
					obj.url = ret.url;
				loopCheck();
			}
		}
		po.fcb = mkf(po);
		plist.push(po);
		$.apiUpload(po.ext,po.content,po.fcb,po.fcb);
	}
}

//用户登陆
$.apiLogin = function(tel,pwd,okf,errf){
	var telwhere = " mobile='"+tel+"'";
	var orgPwd = pwd;
	pwd = md5Twice(pwd);
	var pwdwhere = " and password='"+pwd+"'";
	var b = makepostdata("applogin","r_user",telwhere+pwdwhere,['userid','mobile','nickname','pic',
		makeShowTime('registtime'),'sex','status','username','password']);
	b.mobile = tel;
	function sucf(ret){
		//console.log("login ok:",b,ret);
		if(ret.data && ret.data.length>0){
			var retItem = ret.data[0];
			var u = {};
			u.userid = retItem.userid;
			u.userphone = retItem.mobile;
			u.nickname = retItem.nickname;
			u.userimg = retItem.pic||"";
			u.registtime = retItem.registtime;
			u.sex = retItem.sex==2?"女":"男";
			u.role = (u.status==3)?"业主":(u.status==2?"实名认证用户":"游客");
			u.username = retItem.username;
			u.userpwd = orgPwd;
			u.logon = true;
			u.roomlist;
			u.currentroom;
			$api.setStorage("user",u);
			$.apiGetRooms(okf);
			//极光绑定！
			ajpush_bind(u);
		}
		else{
			$api.setStorage("user",{});
			if(errf)
				errf({msg:"密码错误或账号不存在"});
		}
	}
	$api.setStorage("user",{});
	aj("LOGIN",b,sucf,commNetErrFunc(errf));
}

$.apiSetPwd = function(tel,pwd,okf,errf){
	var telwhere = " mobile='"+tel+"'";
	var orgPwd = pwd;
	pwd = md5Twice(pwd);
	var b = makepostdata("update","r_user",telwhere,{password:sqlstr(pwd)});
	function sucf(ret){
		var u = $api.getStorage("user");
		u.userpwd = orgPwd;
		$api.setStorage("user",u);
		if(okf)okf(ret);
	}
	aj("USER_PWD",b,sucf,errf);
}

$.apiGetUser = function(mobile,okf,errf){
	var b = makepostdata("query","r_user","mobile='"+mobile+"'",["userid","mobile"]);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("USER_GETMOBILE",b,sucf,failf);
}

$.apiSetUser = function(nk,sex,piccontent,tel,okf,errf){
	function dosql(ret){
		//console.log("RT:",ret);
		var u = $api.getStorage("user");
		var pic = "";
		if(ret)
			pic = ret.url;
		var telwhere = " mobile='"+tel+"'";
		var dd = {nickname:sqlstr(nk),sex:sex,username:sqlstr(nk)};
		if(pic)
			dd.pic = pic;
		//console.log("PICC2:",pic);
		var b = makepostdata("update","r_user",telwhere,dd);
		function sucf(ret2){
			u.nickname = nk;
			u.sex = sex==2?"女":"男";
			u.pic = pic;
			$api.setStorage("user",u);
			if(okf)okf(ret2);
		}
		var failf = commNetErrFunc(errf);
		aj("USER_SET",b,sucf,failf);
	}
	//console.log("PICC:",piccontent&&piccontent.length);
	if(piccontent){
		//不管成功失败，都上传
		$.apiUpload(apiGetBase64PicExt(piccontent), piccontent,dosql,dosql);
	}
	else{
		dosql();
	}
}

//新增一个用户信息
$.apiAddUser = function(u,okf,errf){
	var utel = u.userphone;
	var upwd = u.userpwd;
	var pwd = md5Twice(upwd);
	var sex = u.sex=="女"?2:1;
	var role = (u.status=="业主")?3:(u.status=="实名认证用户"?2:1);
	function dosql(ret){
		//console.log("sign ok:",ret);
		var pic = "";
		if(ret)
			pic = ret.url;
		var dd = {nickname:sqlstr(u.nickname),mobile:u.userphone,username:sqlstr(u.nickname),
			identification:u.ident||" ",sex:sex,status:role,password:sqlstr(pwd),registtime:getNowTime()}
		if(pic)
			dd.pic = pic;
		var b = makepostdata("create","r_user",null,dd);
		function doLogin(ret){
			$.apiLogin(utel,upwd,okf,commNetErrFunc(errf));
		}
		aj("USER_ADD",b,doLogin,commNetErrFunc(errf));
	}
	if(u.userimg){
		$.apiUpload(apiGetBase64PicExt(u.userimg), u.userimg,dosql,dosql);
	}
	else{
		dosql();
	}
}

$.apiGetRooms = function(okf,errf){
	var u = $api.getStorage("user")||{};
	var w = " userid='"+u.userid+"' and a.areacode=b.areacode and b.citycode=c.citycode";
	var b = makepostdata("query","r_userarea a,r_area b,r_city c",w,['registid','userid','a.areacode','buildno','roomno',
		'usertype','status','b.displayinfo as areaname','c.displayinfo as cityname','b.checktype']);
	function sucf(ret){
		if(ret.result){
			var u = $api.getStorage("user");
			u.roomlist = ret.data;
			u.areacode = 0;
			var orgRoom = u.currentroom;
			function setRoom(orgRoom){
				u.currentroom = _.find(ret.data,function(it){
					var b = (it.status==2);
					if(orgRoom)
						b = b && orgRoom.areacode == it.areacode;
					if(b){
				    	var hh = '<i class="icon iconfont" style="font-size:20px">&#xf014a;</i> '+it.areaname;
				    	$("#TITLE").html(hh);
						u.areacode = it.areacode;
						//是否自动审核，放在user对象内部。
						u.isAutoCheck = it.checktype == 1;
						$.apiSwitchArea(u.areacode);
					}
					return b;
				})
			}
			//原来就选择了，就先使用原来的。
			if(orgRoom)
				setRoom(orgRoom);
			//还是没找到，就使用默认第一个。
			if(u.areacode == 0)
				setRoom(null);
			$api.setStorage("user",u);
		}
		if(okf) okf(ret);
	}
	aj("USERAREA_SHOW",b,sucf,commNetErrFunc(errf));
}

//新增一个业主信息
$.apiAddRoom = function(u,okf,errf){
	var us = $api.getStorage("user")||{};
	u.ownertype = u.ownertype || "我是租客";
	u.areacode = u.areacode || 0;
	u.build = u.build || 0;
	u.room = u.room || 0;
	var t = (u.ownertype=="我是租客")?3:(u.ownertype=="我是业主家属"?2:1);
	var bb = makepostdata("create","r_userarea",null,{userid:us.userid,areacode:u.areacode,
		buildno:sqlstr(u.build),mobile:u.ownertel,
		roomno:sqlstr(u.room),usertype:t,status:1});
	aj("USERAREA_ADD",bb,okf,commNetErrFunc(errf));
}
var cities;
$.apiGetAllCities = function(okf,errf){
	var b = makepostdata("query","r_city",null,['citycode','displayinfo','displayinfo_en']);
	function sucf(ret){
		if(okf){
			if(ret.result)
				cities = ret.data;
			okf(ret.data);
		}
	}
	if(!cities)
		aj("CITY_SHOW",b,sucf,commNetErrFunc(errf));
	else
		if(okf) okf(cities);
}

$.apiFindCity = function(cityname,okf,errf){
	errf = commNetErrFunc(errf);
	function sucf(ret){
		var tag = _.find(ret,function(item){return item.displayinfo==cityname});
		okf(tag);
	}
	$.apiGetAllCities(sucf,errf);
}

$.apiGetAreaByCity = function(cityname,okf,errf){
	function cityFound(ct){
		if(!ct){
			if(errf)errf({msg:"城市不存在!"});
			return;
		}
		var w = " citycode=\'"+ct.citycode+"'";
		var b = makepostdata("query","r_area",w,['citycode','areacode','displayinfo']);
		aj("AREA_SHOW_BYCITY",b,okf,commNetErrFunc(errf));
	}
	$.apiFindCity(cityname,cityFound,errf);
}

$.apiGetArea = function(areacode,okf,errf){
	var w = areacode?(" areacode="+areacode):"";
	var b = makepostdata("query","r_area",w,['citycode','areacode','displayinfo']);
	aj("AREA_SHOW_BYID",b,okf,commNetErrFunc(errf));
}

$.apiAddBbs = function(bbs,okf,errf){

	function doSql(urls){
		urls = urls || [];
		var u = $api.getStorage("user")||{};
		var areacode = u.areacode||0;
		var userid = u.userid||0;
		var interstObj = {areacode:u.areacode,userid:userid,title:sqlstr(bbs.title||""),
			content:sqlstr(bbs.content||""),pic1:urls[0]||"",pic2:urls[1]||"",pic3:urls[2]||"",
			pic4:urls[3]||"",pic5:urls[4]||"",pic6:urls[5]||"",pic7:urls[6]||"",pic8:urls[7]||"",pic9:urls[8]||""};
		interstObj.status = u.isAutoCheck?2:1;
		var b = makepostdata("create","r_bbs",null,interstObj);
		var failf = commNetErrFunc(errf);
		var sucf = commSuccessFunc(okf,errf);
		aj("BBS_ADD",b,sucf,failf);
	}
	$.apiUploadFileList(bbs.pics,doSql,useProgressBar);
}

$.apiGetBbs = function(topicid,isearly,limit,okf,errf){
	var u = $api.getStorage("user")||{};
	var w = "a.userid = b.userid and a.status=2";
	var areacode = u.areacode||0;
	w += " and a.areacode="+areacode;
	if(topicid){
		if(isearly)
			w += " and a.topicid<'"+topicid+"'";
		else
			w += " and a.topicid>'"+topicid+"'";
	}
	w+=" and a.status=2 order by a.topicid desc";
	w+=" limit "+(limit||10);

	var b = makepostdata("query","r_bbs a,r_user b",w,['a.topicid','a.topicid as id','a.userid','a.title','a.content',
		'a.pic1','a.pic2','a.pic3','a.pic4','a.pic5','a.pic6','a.pic7','a.pic8','a.pic9',
		'b.nickname as username','b.pic as headurl','to_char(createtime, \'MM-DD HH24:MI\') as date',
		'to_char(createtime, \'YYYY-MM-DD HH24:MI:SS\') as ctime']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("BBS_SHOW",b,sucf,failf);
}

$.apiAddActivity = function(hd,okf,errf,prof){
	function doSql(urls){
		urls = urls || [];
		var u = $api.getStorage("user")||{};
		var areacode = u.areacode||0;
		var userid = u.userid||0;
		var b = makepostdata("create","r_activity",null,{areacode:u.areacode,userid:userid,
			title:sqlstr(hd.title||""),content:sqlstr(hd.content||""),pic1:urls[0]||"",pic2:urls[1]||"",pic3:urls[2]||"",
			maxperson:hd.maxperson,begintime:hd.begintime,endtime:hd.endtime,type:hd.type});
		var failf = commNetErrFunc(errf);
		var sucf = commSuccessFunc(okf,errf);
		aj("ACT_ADD",b,sucf,failf);
	}
	$.apiUploadFileList(hd.pics,doSql,useProgressBar);
}

$.apiGetActivity = function(activityid,isearly,limit,okf,errf,hdtype){
	var u = $api.getStorage("user")||{};
	var w = "a.userid = b.userid and a.status=2";
	var areacode = u.areacode||0;
	w += " and a.areacode="+areacode;
	if(activityid){
		if(isearly)
			w += " and a.activityid<"+activityid;
		else
			w += " and a.activityid>"+activityid;
	}
	if(hdtype)
		w += " and a.type="+hdtype;
	w+=" and a.status=2 order by a.activityid desc";
	w+=" limit "+(limit||10);

	var b = makepostdata("query","r_activity a,r_user b",w,['a.activityid as id','a.activityid','a.userid','a.title','a.content',
		'a.pic1','a.pic2','a.pic3','a.maxperson','to_char(a.begintime, \'YYYY年MM月DD日 HH24点MI分\') as begintime','to_char(a.endtime, \'YYYY年MM月DD日 HH24点MI分\') as endtime','a.type',
		'b.nickname as username','b.pic as headurl','to_char(createtime, \'MM-DD HH24:MI\') as date',
		'to_char(createtime, \'YYYY-MM-DD HH24:MI:SS\') as ctime']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("ACT_SHOW",b,sucf,failf);
}

$.apiAddActLike = function(actid,okf,errf){
	var u = $api.getStorage("user")||{};
	var userid = u.userid||0;
	var b = makepostdata("create","r_activityowner",null,{activityid:actid,userid:userid});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("ACT_ADDOWNER",b,sucf,failf);
}

$.apiGetActLike = function(actid,okf,errf){
	var w = " activityid="+actid;
	var b = makepostdata("query","r_activityowner",w,['activityid','userid',makeShowTime('createtime')]);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("ACT_LIKECNT",b,sucf,failf);
}

$.apiAddBBSLike = function(tid,okf,errf){
	var u = $api.getStorage("user")||{};
	var userid = u.userid||0;
	var b = makepostdata("create","r_bbslike",null,{topicid:tid,userid:userid});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("BBS_ADDLIKE",b,sucf,failf);
}

$.apiDelBBSLike = function(tid,okf,errf){
	var u = $api.getStorage("user")||{};
	var userid = u.userid||0;
	var w = " userid="+userid;
	w += " and topicid="+tid||0;
	var b = makepostdata("delete","r_bbslike",w,{});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("BBS_DELLIKE",b,sucf,failf);
}

$.apiGetBBSLike = function(tid,okf,errf){
	var w = " topicid="+tid;
	var b = makepostdata("query","r_bbslike",w,['topicid','userid',makeShowTime('liketime')]);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("BBS_LIKECNT",b,sucf,failf);
}

$.apiGetServiceLike = function(tid,okf,errf){
	var w = " serviceid="+tid;
	var b = makepostdata("query","r_servicelike",w,['serviceid','userid',makeShowTime('liketime')]);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("SERVICE_LIKECNT",b,sucf,failf);
}

$.apiAddServiceLike = function(tid,okf,errf){
	var u = $api.getStorage("user")||{};
	var userid = u.userid||0;
	var b = makepostdata("create","r_servicelike",null,{serviceid:tid,userid:userid});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("SERVICE_ADDLIKE",b,sucf,failf);
}

$.apiDelServiceLike = function(tid,okf,errf){
	var u = $api.getStorage("user")||{};
	var userid = u.userid||0;
	var w = " userid="+userid;
	w += " and serviceid="+tid||0;
	var b = makepostdata("delete","r_servicelike",w,{});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("SERVICE_DELLIKE",b,sucf,failf);
}

$.apiAddBBSComment = function(tid,content,okf,errf){
	var u = $api.getStorage("user")||{};
	var userid = u.userid||0;
	var b = makepostdata("create","r_bbsreply",null,{topicid:tid,userid:userid,replycontent:content});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("BBS_COMMENT",b,sucf,failf);
}

$.apiGetBBSComment = function(tid,okf,errf){
	var w = " a.userid = b.userid and a.topicid="+tid + " order by a.replytime ";
	var b = makepostdata("query","r_bbsreply as a,r_user b",w,['a.userid','a.topicid','b.pic as headurl','b.nickname as username','a.replycontent as content','to_char(a.replytime, \'MM-DD HH24:MI\') as date']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("BBS_COMMENTCNT",b,sucf,failf);
}

$.apiGetNotice = function(ctime,isearly,limit,okf,errf){
	var u = $api.getStorage("user")||{};
	var w = "";
	w += "a.areacode="+(u.areacode||0);
	if(ctime){
		if(isearly)
			w += " and publishtime<'"+ctime+"'";
		else
			w += " and publishtime>'"+ctime+"'";
	}
	w+=" and status=2 order by publishtime desc";
	w+=" limit "+(limit||10);

	var b = makepostdata("query","r_notice a",w,['noticeid as id','a.title','a.content','a.pic',
		'to_char(publishtime, \'MM-DD HH24:MI\') as date','to_char(publishtime, \'YYYY-MM-DD HH24:MI:SS\') as ctime']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("NOTICE_SHOW",b,sucf,failf);
}

$.apiGetNoticeByID = function(id,okf,errf){
	var w = " noticeid="+id;
	var b = makepostdata("query","r_notice a",w,['noticeid as id','a.title','a.content','a.pic',
		'to_char(publishtime, \'MM-DD HH24:MI\') as date','to_char(publishtime, \'YYYY-MM-DD HH24:MI:SS\') as ctime']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("NOTICE_SHOW_BYID",b,sucf,failf);
}

$.apiGetService = function(ctime,isearly,limit,okf,errf){
	var u = $api.getStorage("user")||{};
	var w = "";
	w += "a.areacode="+(u.areacode||0);
	if(ctime){
		if(isearly)
			w += " and publishtime<'"+ctime+"'";
		else
			w += " and publishtime>'"+ctime+"'";
	}
	w+=" and status=2 order by publishtime desc";
	w+=" limit "+(limit||10);

	var b = makepostdata("query","r_service a",w,['serviceid as id','a.serviceitem as title','a.info as content','a.pic1','a.pic2','a.pic3',
		'to_char(servicetime, \'MM-DD HH24:MI\') as date','to_char(publishtime, \'YYYY-MM-DD HH24:MI:SS\') as ctime']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("SERVICE_SHOW",b,sucf,failf);
}

$.apiGetServiceByID = function(id,okf,errf){
	var w = " serviceid="+id;
	var b = makepostdata("query","r_service a",w,['serviceid as id','a.serviceitem as title','a.info as content','a.pic',
		'to_char(servicetime, \'MM-DD HH24:MI\') as date','to_char(publishtime, \'YYYY-MM-DD HH24:MI:SS\') as ctime']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("SERVICE_SHOW_BYID",b,sucf,failf);
}

$.apiGetVC = function(okf,errf){
	var dt = (new Date).format("yyyy-MM-dd");
	var u = $api.getStorage("user")||{};
	var w = "status=1";
	var areacode = u.areacode||0;
	w += " and invaliddate>='"+dt+"'";
	w += " and areacode="+areacode;
	w += " and userid="+u.userid;
	w += " order by sequencecode desc";

	var b = makepostdata("query","r_visitorcode",w,['sequencecode','visitorcode','to_char(createtime, \'YYYY-MM-DD HH24:MI:SS\') as createtime',
		'to_char(visitordate, \'YYYY-MM-DD\') as visitordate','to_char(invaliddate, \'YYYY-MM-DD\') as invaliddate']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("VISITORCODE_SHOW",b,sucf,failf);
}

$.apiGetVistorcode = function(lfdt,sxdt,okf,errf){
	var u = $api.getStorage("user")||{};
	var b = makepostdata("query","proc_jct_create_visitorcode("+u.areacode+","+u.userid+",'"+u.currentroom.buildno
		+"','"+u.currentroom.roomno+"','"+lfdt+"','"+sxdt+"')",null,['visitorcode as code']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("VISITORCODE_GET",b,sucf,commNetErrFunc(errf));
	//sucf({result:true,data:[{code:"7862713"}]});
}

$.apiInvalidVC = function(seq,okf,errf){
	var w = " sequencecode="+seq;
	var b = makepostdata("update","r_visitorcode",w,{status:0});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("VISITORCODE_INVALID",b,sucf,errf);
}

$.apiAddEvent = function(hd,okf,errf){
	function doSql(urls){
		urls = urls || [];
		var u = $api.getStorage("user")||{};
		var areacode = u.areacode||0;
		var userid = u.userid||0;
		var b = makepostdata("create","r_event",null,{areacode:u.areacode,userid:userid,
			content:sqlstr(hd.content||""),pic1:urls[0]||"",pic2:urls[1]||"",pic3:urls[2]||"",
			buildno:hd.buildno,roomno:hd.roomno,contactmobile:hd.contactmobile,status:1});
		var failf = commNetErrFunc(errf);
		var sucf = commSuccessFunc(okf,errf);
		aj("EVNT_ADD",b,sucf,failf);
	}
	$.apiUploadFileList(hd.pics,doSql,useProgressBar);
}

$.apiAssessEvent = function(id,level,acontent,okf,errf){
	var w = " eventid="+id;
	var b = makepostdata("update","r_event",w,{assesslevel:level,status:3,accesscontent:acontent});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("EVENT_ASSESS",b,sucf,errf);
}

$.apiGetEventByID = function(id,okf,errf){
	var w = " eventid="+id;
	var b = makepostdata("query","r_event",w,['eventid','buildno','roomno',
		'pic1','pic2','pic3','status','content','result','assesslevel',
		makeShowTime('eventtime')]);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("NOTICE_SHOW_BYID",b,sucf,failf);
}

$.apiAddRepair = function(hd,okf,errf){
	function doSql(urls){
		urls = urls || [];
		var u = $api.getStorage("user")||{};
		var areacode = u.areacode||0;
		var userid = u.userid||0;
		var serob = {areacode:u.areacode,userid:userid,
			content:sqlstr(hd.content||""),pic1:urls[0]||"",pic2:urls[1]||"",pic3:urls[2]||"",
			buildno:hd.buildno,roomno:hd.roomno,contactmobile:hd.contactmobile,status:1,repairtype:hd.repairtype};
		if(hd.repaireitemid){
			serob.repaireitemid = hd.repaireitemid;
		}
		var b = makepostdata("create","r_repair",null,serob);
		var failf = commNetErrFunc(errf);
		var sucf = commSuccessFunc(okf,errf);
		aj("REPAIR_ADD",b,sucf,failf);
	}
	$.apiUploadFileList(hd.pics,doSql,useProgressBar);
}

$.apiGetRepairByID = function(id,okf,errf){
	var w = " repairid="+id;
	var b = makepostdata("query","r_repair",w,['repairid','buildno','roomno','repaireitemid',
		'pic1','pic2','pic3','status','content','result', 'repairtype','assessitem','assesslevel',
		makeShowTime('repairtime'),makeShowTime('reporttime')]);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("REPAIR_SHOW_BYID",b,sucf,failf);
}

$.apiGetRepairItemByID = function(id,okf,errf){
	var w = " itemid="+id;
	var b = makepostdata("query","r_repairitem",w,['itemid','itemcontent']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("REPAIRITEM_SHOW_BYID",b,sucf,failf);
}

$.apiAssessRepair = function(id,level,ait,acontent,okf,errf){
	var w = " repairid="+id;
	var ob = {assesslevel:level,status:3,accesscontent:acontent};
	if(ait){
		ob.assessitem = ait;
	}
	var b = makepostdata("update","r_repair",w,ob);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("REPAIR_ASSESS",b,sucf,errf);
}

$.apiAddComplaint = function(hd,okf,errf){
	var u = $api.getStorage("user")||{};
	var areacode = u.areacode||0;
	var userid = u.userid||0;
	var b = makepostdata("create","r_complaint",null,{areacode:u.areacode,userid:userid,
		content:sqlstr(hd.content||""),contactmobile:hd.contactmobile,status:1});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("COMPLAINT_ADD",b,sucf,failf);
}

$.apiGetComplaintByID = function(id,okf,errf){
	var w = " complaintid="+id;
	var b = makepostdata("query","r_complaint",w,['complaintid','status','content','result', 
		makeShowTime('complainttime')]);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("COMPLAINT_SHOW_BYID",b,sucf,failf);
}

$.apiGetShop = function(id,isearly,limit,okf,errf){
	var u = $api.getStorage("user")||{};
	var w = "status=2";
	var areacode = u.areacode||0;
	w += " and areacode="+areacode;
	if(id){
		if(isearly)
			w += " and shopid<"+id;
		else
			w += " and shopid>"+id;
	}
	w+=" order by shopid desc";
	w+=" limit "+(limit||10);

	var b = makepostdata("query","r_shop",w,['shopid','shopname','business',
		'phone','address',
		'to_char(begintime, \'HH24:MI\') as begintime','to_char(endtime, \'HH24:MI\') as endtime']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("SHOP_SHOW",b,sucf,failf);
}

$.apiAddHouseBiz = function(hz,okf,errf){
	function doSql(urls){
		urls = urls || [];
		var u = $api.getStorage("user")||{};
		var areacode = u.areacode||0;
		var userid = u.userid||0;
		var b = makepostdata("create","r_housingrental",null,{areacode:u.areacode,userid:userid,
			buildno:hz.buildno,roomno:hz.roomno,roomtype:sqlstr(hz.roomtype||""),rentaltype:hz.type,
			contact:hz.contact,contactmobile:hz.contactmobile,price:hz.price,
			info:sqlstr(hz.info||""),pic1:urls[0],pic2:urls[1],pic3:urls[2],
			pic4:urls[3],pic5:urls[4],pic6:urls[5],pic7:urls[6],pic8:urls[7],pic9:urls[8]});
		var failf = commNetErrFunc(errf);
		var sucf = commSuccessFunc(okf,errf);
		aj("HOUSEBIZ_ADD",b,sucf,failf);
	}
	$.apiUploadFileList(hz.pics,doSql,useProgressBar);
}

$.apiGetHouseBiz = function(type,ctime,isearly,limit,okf,errf){
	var u = $api.getStorage("user")||{};
	var w = "a.userid = b.userid and a.status=2";
	var areacode = u.areacode||0;
	w += " and a.areacode="+areacode;
	if(ctime){
		if(isearly)
			w += " and a.createtime<'"+ctime+"'";
		else
			w += " and a.createtime>'"+ctime+"'";
	}
	if(type)
		w+= " and a.rentaltype="+type;
	w+=" order by a.createtime desc";
	w+=" limit "+(limit||10);

	var b = makepostdata("query","r_housingrental a,r_user b",w,['a.rentalid','a.rentalid as id','a.userid',
		'a.pic1','a.pic2','a.pic3','a.pic4','a.pic5','a.pic6','a.pic7','a.pic8','a.pic9',
		'a.buildno','a.roomno','a.roomtype','a.info','a.rentaltype as type','a.price',
		'a.contact','a.contactmobile','b.nickname as username','b.pic as headurl',
		'to_char(createtime, \'YYYY-MM-DD HH24:MI:SS\') as ctime']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("HOUSEBIZ_SHOW",b,sucf,failf);
}

$.apiGetHouseBizByID = function(id,okf,errf){
	var w = "a.rentalid = "+id;
	w += " and a.userid = b.userid";
	var b = makepostdata("query","r_housingrental a,r_user b",w,['a.rentalid','a.rentalid as id','a.userid',
		'a.pic1','a.pic2','a.pic3','a.pic4','a.pic5','a.pic6','a.pic7','a.pic8','a.pic9',
		'a.buildno','a.roomno','a.roomtype','a.info','a.rentaltype as type','a.price',
		'a.contact','a.contactmobile','b.nickname as username','b.pic as headurl',
		'to_char(createtime, \'YYYY-MM-DD HH24:MI:SS\') as ctime']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("HOUSEBIZ_SHOW_BYID",b,sucf,failf);
}

$.apiGetAdvert = function(okf,errf){
	var u = $api.getStorage("user")||{};
	var areacode = u.areacode||0;
	var	w = " status=2 and areacode="+areacode;
	var b = makepostdata("query","r_advert",w,['advertid',"'"+JCTHOST+"'||"+'bannerpic as bannerpic',
		"'"+JCTHOST+"'||"+'singlepic as singlepic','status','module']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("ADVERT_SHOW",b,sucf,failf);
}

$.apiGetAccessItems = function(okf,errf){
	var u = $api.getStorage("user")||{};
	var areacode = u.areacode||0;
	//select a.itemid,a.itemcontent from r_accessitem a ,r_propertycompany b,r_area c where a.pccode=b.pccode and b.pccode=c.pccode and c.areacode=3

	var	w = " a.pccode=b.pccode and b.pccode=c.pccode and c.areacode="+areacode + " order by a.itemid";
	var b = makepostdata("query","r_accessitem a ,r_propertycompany b,r_area c",w,['a.itemid','a.itemcontent']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("ACCESS_SHOW",b,sucf,failf);
}

$.apiGetRepairItems = function(okf,errf){
	var u = $api.getStorage("user")||{};
	var areacode = u.areacode||0;

	var	w = " a.pccode=b.pccode and b.pccode=c.pccode and c.areacode="+areacode + " order by a.itemid";
	var b = makepostdata("query","r_repairitem a ,r_propertycompany b,r_area c",w,['a.itemid','a.itemcontent']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("REPAIR_ITEM_SHOW",b,sucf,failf);
}

function getMatter(ww,apiname,okf,errf){
	var u = $api.getStorage("user")||{};
	var areacode = u.areacode||0;
	var w = " areacode="+areacode;
	w += " and userid="+u.userid;
	w += ww;
	w += " order by mattertime desc";
	var b = makepostdata("query","view_jct_mymatters",w,[
		"(extract(year from mattertime)||'年'||extract(month from mattertime)||'月') as mon",'mattertype','matterid',
		'subtype','content','mattertime','status']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj(apiname,b,sucf,failf);
}

$.apiGetMyBiz = function(okf,errf){
	getMatter(" and mattertype in (1,2,3)","MYBIZ_SHOW",okf,errf);
}

$.apiGetMySrv = function(okf,errf){
	getMatter(" and mattertype=4","MYSRV_SHOW",okf,errf);
}

$.apiGetMyPaylog = function(okf,errf){
	var u = $api.getStorage("user")||{};
	var areacode = u.areacode||0;
	var w = " areacode="+areacode;
	w += " and userid="+u.userid;
	var dv = (new Date()).getTime();
	var d = new Date
	d.setTime(dv - 3*30*24*60*60*1000);
	d = d.format("yyyy-MM");
	//console.log(d);
	w += " and to_char(createtime,'YYYY-MM')>'"+d+"'";
	w += " order by createtime desc";
	var b = makepostdata("query","r_paylog",w,["5 as mattertype","payid as matterid","outtradeno",
		"(extract(year from createtime)||'年'||extract(month from createtime)||'月') as mon",
		'type','fee',makeShowTime('createtime'),'status','detailinfo as content','paytype','payto']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("MYORDER_SHOW",b,sucf,failf);
}

$.apiGetUnPaylog = function(type,okf,errf){
	var u = $api.getStorage("user")||{};
	var areacode = u.areacode||0;
	var w = " areacode="+areacode;
	w += " and userid="+u.userid;
	w += " and type="+type;
	w += " and status=1 order by createtime desc";
	var b = makepostdata("query","r_paylog",w,["payid","outtradeno",
		"(extract(year from createtime)||'年'||extract(month from createtime)||'月') as mon",
		'type','fee',makeShowTime('createtime'),'status','detailinfo as content','paytype','payto']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("UNPAY_SHOW",b,sucf,failf);
}


$.apiGetPaylogByTradeno = function(tradeno,okf,errf){
	var u = $api.getStorage("user")||{};
	var areacode = u.areacode||0;
	var w = " outtradeno='"+tradeno+"'";
	var b = makepostdata("query","r_paylog",w,["payid","outtradeno",
		'type','fee',makeShowTime('createtime'),'status','detailinfo as content','paytype','payto']);
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("PAY_TRADENO_SHOW",b,sucf,failf);
}


//TEMP API
$.apiUnlock = function(okf,errf){
	var u = $api.getStorage("user")||{};
	var w = "a.mobile = b.mobile and a.mobile='"+u.userphone+"'";
	var b = makepostdata("query","r_user a, r_owner b",w,['carlicense']);
	var failf = commNetErrFunc(errf);
	var sucf = function(ret){
		if(ret && ret.result){
			var carno = ret.data && ret.data[0] && ret.data[0].carlicense;
			//console.log(">>",carno);
			var areacode = u.areacode||0;

			var params = {"bureauno":areacode,"carnumber":carno,"unlock":true};

	        api.ajax({
	            method : "post",
	            data: {values:params},
	            url: "http://101.200.199.5:3900/unlock",
	            timeout:10000
	          },function(ret,error){
	          //console.log(">>>:",ret,"ERR:",error);
	          if(ret){
	            if($.isFunction(okf)) okf(ret);
	          }
	          else{
	            if($.isFunction(failf)) failf(error);
	          }
	        });
		}
		else failf();
	};
	aj("SHOW_CARNO",b,sucf,failf);
}

///JCT API
$.apiSendActivateCode = function(tel,sms,okf,errf){
	if(typeof api != "undefined")
		$.pa.setApiProxy(APIHOST);
	var opts = {success:okf,error:errf,timeout:10000,url:"/action"};
	opts.input = {action:"activatecode",data:{mobile:tel,code:sms}};
	$.pa.execute("SEND_ACTCODE",opts);
}

$.apiPayGetMobileProducts = function(okf,errf){
	var opts = {success:okf,error:errf,timeout:10000,url:"/pay"};
	opts.input = {action:"init",model:"mobile_init"};
	$.pa.execute("PAY_MOBPRO",opts);
}

$.apiPayGetOilCardProducts = function(okf,errf){
	var opts = {success:okf,error:errf,timeout:10000,url:"/pay"};
	opts.input = {action:"init",model:"oil_init"};
	$.pa.execute("PAY_OILPRO",opts);
}

$.apiPayGetFixedTelProducts = function(okf,errf){
	var opts = {success:okf,error:errf,timeout:10000,url:"/pay"};
	opts.input = {action:"init",model:"fixedTelphone_init"};
	$.pa.execute("PAY_FTPRO",opts);
}

$.apiPayMobile = function(dt,okf,errf){
	deviceChoosePayWay(function(paytype){
		var opts = {success:getPayFunc(okf,errf,jctPrepay),error:errf,timeout:10000,url:"/pay"};
		opts.input = {action:"confirm",model:"mobile_queryPhoneNo",data:dt,paytype:paytype};
		$.pa.execute("PAY_MOB",opts);
	});
}

$.apiPayOilCard = function(dt,okf,errf){
	deviceChoosePayWay(function(paytype){
		var opts = {success:getPayFunc(okf,errf,jctPrepay),error:errf,timeout:10000,url:"/pay"};
		opts.input = {action:"confirm",model:"oil_toTrade",data:dt,paytype:paytype};
		$.pa.execute("PAY_OIL",opts);
	});
}

$.apiPayFixedTel = function(dt,okf,errf){
	deviceChoosePayWay(function(paytype){
		var opts = {success:getPayFunc(okf,errf,jctPrepay),error:errf,timeout:10000,url:"/pay"};
		opts.input = {action:"confirm",model:"fixedTelphone_toTrade",data:dt,paytype:paytype};
		$.pa.execute("PAY_FIXTEL",opts);
	});
}

$.apiSetTradeNo = function (tradeno,newno,paytype,okf,errf){
	var w = " outtradeno='"+tradeno+"'";
	var b = makepostdata("update","r_paylog",w,{outtradeno:newno,paytype:paytype});
	var failf = commNetErrFunc(errf);
	var sucf = commSuccessFunc(okf,errf);
	aj("PAYLOG_SET_TRNO",b,sucf,failf);
}

function jctPrepay(ret){
	var result = ret.result;
	var wxopt = {
		description : result.proName||result.proCode,
		totalFee : USEDEBUG?1:(parseInt(result.feeMoney)+parseInt(result.money))*100,
		tradeNo : ret.outtradeno,
		productId : ret.outtradeno
	}
	return wxopt;
}

function setTradeFail(tradeno){
	var w = " status=3";
	var b = makepostdata("update","r_paylog",w,{outtradeno:tradeno});
	aj("PAYLOG_SET_FAIL",b,$.noop,$.noop);
}

function getPayFunc(okf,errf,prePay){
	return function(ret){
		//console.log("JCT RET:",ret);
		if(ret){
			if(ret.status=="success"){
				var opt = prePay(ret);
				function failf(er){
					if(errf)
						errf(er);
					if(opt && opt.tradeNo)
						setTradeFail(opt.tradeNo);
				}
				devicePay(opt,okf,failf);
				return;
			}
			else{
				alert(ret.msg);
			}
		}
		errf("访问参数错误");
	}
}

$.apiPayDirect = function(hd,okf,errf){
	deviceChoosePayWay(function(paytype){
		var u = $api.getStorage("user")||{};
		var areacode = u.areacode||0;
		var userid = u.userid||0;
		var tn = GetTradeNo();
		//alert("PAYTYPE:"+paytype);
		//console.log(tn);
		var b = makepostdata("create","r_paylog",null,{areacode:u.areacode,userid:userid,
			type:hd.type,fee:hd.fee,status:1,detailinfo:hd.info,paytype:paytype,payto:hd.payto,outtradeno:tn});
		var payopt = {
			description : hd.info,
			totalFee : hd.fee,
			tradeNo : tn,
			productId : tn
		};
		var compf = function(ret){
			if(ret && ret.result){
				function ff(er){
					//alert("支付失败");
					if(errf){
						errf(er);
					}
					setTradeFail(tn);
				}
				devicePay(payopt,okf,ff);
				return;
			}
			alert("支付失败:订单生产失败");
			if(errf)
				errf();
		}
		aj("PAY_DIRECT",b,compf,compf);
	},hd);
}

})($);