
/*(function(){
	$.os = {};
})();*/
var _logList = [];

toastDlg = function(str){
	$.tips({
	    content:str,
	    stayTime:3000,
	    type:"info"
   });
}
//系统方法替换
var deviceInit = function(){
	//启动前先预置。
	var bs = $api.getStorage("base")||{};
	if(!bs.city)
	{
		setBaseInfo("city","上海");
	}

	if(typeof(api) == "undefined")
		return;

	api.setScreenOrientation({
    	orientation:'auto_portrait'
	});

	console.log = (function(oriLogFunc){
		return function(str)
		{
			if(!USEDEBUG) return;
			try{

			var sa = arguments;
			var t = "";
			for(var arg in sa)
			{
				var ob = sa[arg];
				var val = ob +' ';
				if(typeof ob == 'object' || typeof ob == 'array')
				{
					try{
						val = JSON.stringify(ob);
					}catch(EE){
						
					}
				}
				t += val +" ";
			}
		    oriLogFunc.call(console,t);
		    var dt = (new Date).format("[hh:mm:ss]");
			_logList.unshift({c:t,d:dt});

			}catch(ee){};
		}
	})(console.log);

	window.alert = function(str){
		api.alert({msg:str||""});
	}

	window.toastDlg = function(str){
		api.toast({
		    msg: str,
		    duration:3000,
		    location: 'top'
		});
	}

	deviceIsIos7();
	setBaseInfo('gpscity',null);

	//keyboard bug
	(function(){
		var initBodyHeight = window.innerHeight;
		var keyBoardStatus = false;

		function kbopen(){
			var ev = document.createEvent('HTMLEvents');
			ev.initEvent('keyboardOpen', false, false);
			document.dispatchEvent(ev);
			console.log('KB open');
			keyboardState = "open";
		}
		function kbclose(){
			var ev = document.createEvent('HTMLEvents');
			ev.initEvent('keyboardClosed', false, false);
			document.dispatchEvent(ev);
			console.log('KB close');
			keyboardState = "closed";
		}

		var getKeyBoardStatus = function(){
		    setTimeout(function(){
		        if(initBodyHeight != window.innerHeight && keyBoardStatus == false){
		            keyBoardStatus = true;
		            kbopen();
		            getKeyBoardStatus();
		            return false;
		        }
		        if(initBodyHeight == window.innerHeight && keyBoardStatus == true){
		            keyBoardStatus = false;
		            kbclose();
		            getKeyBoardStatus();
		            return false;
		        }
		        getKeyBoardStatus();
		    },200);
		}
		getKeyBoardStatus();
	})();
	wx_config();
    ajpush_init();

	wxPay = api.require('wxPay');
};

//微信pay配置
function wx_config(okf){
	var wxPay = api.require('wxPay');
	wxPay.config({
	     apiKey: WX_appid,
	     mchId: WX_mch_id,
	     partnerKey: WX_KEY,
	     notifyUrl: WX_notifyUrl
	}, function(ret, err){
	     if(ret.status){
	        console.log("WXPAY CONFIG OK:",ret);
	        if(okf)
	        	okf();
	     }else{
	        console.log("WXPAY CONFIG ERROR:",err);
	     }
	});
}

//支付宝配置
function alipay_config(okf){
    var aliPay = api.require('aliPay');
    aliPay.config({
        partner:aliPay_partner,
        seller:aliPay_seller,
        rsaPriKey:aliPay_rsaPriKey,
        rsaPubKey:aliPay_rsaPubKey,
        notifyURL:aliPay_notifyURL
    }, function(ret, err){
         if(ret.status){
            console.log("ALIPAY CONFIG OK:",ret);
            if(okf)
                okf();
         }else{
            console.log("ALIPAY CONFIG ERROR:",err);
         }
    });
}

//极光推送
function ajpush_init(){
    var ajpush = api.require('ajpush');

    var isAndroid = (/android/gi).test(navigator.appVersion);
    if(isAndroid){
	    ajpush.init(function(ret) {
	        if (!ret || !ret.status){
	            alert("消息推送初始化失败！");
	        }
	    });
	    ajpush.getRegistrationId(function(ret) {
		    var registrationId = ret.id;
		    //alert(registrationId);
		});
    }
    else{
	    ajpush.getRegistrationId(function(ret) {
		    var registrationId = ret.id;
		    //alert(registrationId);
		});
    }

     api.addEventListener({name:'appintent'}, function(ret,err) {
         //alert('通知被点击，收到数据：\n' + JSON.stringify(ret));//监听通知被点击后收到的数据
        // var ajpush = ret.appParam.ajpush; 
        // var jsonStr = JSON.parse(ajpush.extra); 
        // var type = jsonStr.type; 
        // var id = jsonStr.txt;
     });

     api.addEventListener({name:'pause'}, function(ret,err) {
         ajpush.onPause();
         console.log('JPush onPause');
         //监听应用进入后台，通知jpush暂停事件
     });
         
     api.addEventListener({name:'resume'}, function(ret,err) {
         ajpush.onResume();
         console.log('JPush onResume');
         //监听应用恢复到前台，通知jpush恢复事件
     });

     ajpush.setListener(
        function(ret) {
            alert(ret.content);
        }
    );
}

//用户绑定
function ajpush_bind(user){
    if(typeof(api) == "undefined")
        return;
    if(!user || !user.userphone){
    	return;
    }
    var param = {tags : [user.userphone]};
    var ajpush = api.require('ajpush');
    ajpush.bindAliasAndTags(param, function(ret) { 
        //alert('别名设置成功'); 
    });
}

var __LOADINGELE;

function showLoading(info){
	closeLoading();
	__LOADINGELE = $.loading({content:info});
	setTimeout(function(){
		closeLoading();
	},20000);
}

function closeLoading(){
	if(__LOADINGELE){
		$(__LOADINGELE).remove();
	}
}

function htmlEncode(str)   
{   
  var s = "";
  str = str || "";
  if (str.length == 0) return "";   
  s = str.replace(/&/g, "&gt;");   
  s = s.replace(/</g, "&lt;");   
  s = s.replace(/>/g, "&gt;");   
  s = s.replace(/ /g, "&nbsp;");   
  s = s.replace(/\'/g, "&#39;");   
  s = s.replace(/\"/g, "&quot;");   
  s = s.replace(/\n/g, "<br>");   
  return s;   
}   
 
function htmlDecode(str)   
{   
  var s = "";   
  str = str || "";
  if (str.length == 0) return "";   
  s = str.replace(/&gt;/g, "&");   
  s = s.replace(/&lt;/g, "<");   
  s = s.replace(/&gt;/g, ">");   
  s = s.replace(/&nbsp;/g, " ");   
  s = s.replace(/&#39;/g, "\'");   
  s = s.replace(/&quot;/g, "\"");   
  s = s.replace(/<br>/g, "\n");   
  return s;   
}

var keyboardState = "closed";

//buttons:[{name:"确定",func:doSomething},{name:"取消"}]
function confirmDlg(info,buttons){
	var bh = "";
	_.each(buttons,function(bt){
		bh += '<button type="button" data-role="button" id="_CONFRIMBT_'+bt.name+'">'+bt.name+'</button>';
	})
	var h = '<div class="ui-dialog show" id="_CONFIRM"> \
	    <div class="ui-dialog-cnt"> \
	        <div class="ui-dialog-bd"> \
	            <div>'+ info +'</div> \
	        </div> \
	        <div class="ui-dialog-ft ui-btn-group">'+bh+'</div> \
	    </div>        \
	</div>'
	$('body').append(h);
	_.each(buttons,function(bt){
		var id = '#_CONFRIMBT_'+bt.name;
		$(id).tap(function(){
			if(bt.func)
				bt.func();
			$('#_CONFIRM').remove();
		});
	})
}

function showLog(){
	$('#bugLog').remove();
	var h = "<div id='bugLog' style='left: 0;top: 0;z-index:99999;background-color:white;position:fixed;height:"+
		$(window).height()+"px;width:100%'>";
	h+="<p style='margin-top:20px'><a href='#' ontouchend='$(\"#bugLog\").remove()'> \
		X关闭</a><a style='padding-left:100px' href='#' \
		 ontouchend='_logList=[];showLog()'>清空</a></p>";
	for(var i in _logList){
		var lg = _logList[i];
		h+="<p style='font-size:8px;' class='ui-border-t'>"+lg.d+lg.c+"</p>";
	}
	h+="</div>";
	$('body').append(h);
}

// KC_注释掉部分

//粘贴板
//function clipBoard(v,alert){
//	if(typeof(api) == "undefined")
//		return false;
//	var obj = api.require('clipBoard');
//	//console.log('copy words:',[v,obj]);
//	obj.set({
//	    value: v
//	}, function(ret, err){
//		if(alert === false) return;
//	    if(ret.status){
//	        api.alert({msg:'已成功复制到剪切板',buttons:['确定']});
//	    }else{
//	        console.log({msg:err.msg});
//	    }
//	});
//}

// **************************************************kc_添加《验证码》分享短信和微信 开始部分********************************************//

// KC_添加分享actionAlert
function clickShareView(text){
		var myUser = $api.getStorage("user")||{};
		var text = text+"————"+myUser.currentroom.areaname+"小区访客通行码，请在进入小区时告知门卫保安，祝您生活愉快！";
		api.actionSheet({title: '分享给朋友', cancelTitle: '取消', buttons: ['短信','微信朋友']},function(ret,err){
    			if (ret.buttonIndex == 1){
    				clipBoard(text);
    			}
    			if (ret.buttonIndex == 2){
    				//alert("跳转到微信分享界面")
    				weatherOrNotInitialWx(text);
    			}
	});
}

// KC_修改粘贴板
function clipBoard(v,alert){
	if(typeof(api) == "undefined") return false;
	var obj = api.require('clipBoard');
	//console.log('copy words:',[v,obj]);
	obj.set({value: v}, function(ret, err){
		if(alert === false) return;
	    if(ret.status){
	        api.sms({numbers: [''], text: v}, function(ret, err){
    			if(ret.status){
        			api.alert({msg:'发送成功'});
    				} 
			});
	    }else{
	        console.log({msg:err.msg});
	    }
	});
}

// KC_添加是否安装微信客户端判断
function weatherOrNotInitialWx(text){
		var wx = api.require('wx');
		wx.isInstalled(function(ret, err){
    			if(ret.installed){
    				//alert("当前设备已经安装微信客户端");
    				shareToWx(text);
    			}else{
        			alert('当前设备未安装微信客户端');
    			}
	});
}

// KC_添加微信分享文本内容（使用的是分享网页链接的API，原因是ShareText不支持纯文本发送给朋友）
function shareToWx(myShareText){
		var myUser = $api.getStorage("user")||{};
		var wx = api.require('wx');
		wx.shareWebpage({apiKey: '',
    			scene: 'session',
    			title: myShareText,
    			description: '  '+myUser.currentroom.areaname+'小区访客通行码，请在进入小区时告知门卫保安，祝您生活愉快！',
    			thumb: 'widget://image/logo.jpg',
    			contentUrl: 'http://www.e-wuye.com/app.html'
			}, function(ret, err){
    			if(ret.status){
        			alert('分享成功');
        			landAuthorization();
    			}else{
        			//alert(err.code);
    			}
			});
}

// KC_登录授权
function landAuthorization(){
		var wx = api.require('wx');
		wx.auth({apiKey: ''}, function(ret, err){ 
    			if(ret.status){
        			//alert(JSON.stringify(ret));
        			getAccessToken();
    			}else{
        			//alert(err.code);
    			}
	});
}

// KC_微信accessToken获取
function getAccessToken(){
		var wx = api.require('wx');
		wx.getToken({apiKey: '', apiSecret: '', code: "12346857684"},function(ret, err){ 
    			if(ret.status){
        			//alert(JSON.stringify(ret));
        			getUserInfo(ret.accessToken, ret.openId, ret.dynamicToken);
    			}else{
        			//alert(err.code);
    			}
	});
}

// KC_获取UserInfo
function getUserInfo(getToken, getOpenId, getDynamicToken){
		var wx = api.require('wx');
		wx.getUserInfo({accessToken: getToken, openId: getOpenId}, function(ret,err){ 
    			if(ret.status){
        			//alert(JSON.stringify(ret));
    			}else{
        			alert(err.code);
        			if (err.code == 1) {
        				refreshToken(getDynamicToken);
        			}
    			}
	});
}

// KC_当返回错误码是1时，表示过期，需重新调用userInfo这个接口
function refreshToken(getDynamicToken){
		var wx = api.require('wx');
		wx.refreshToken({apiKey: '', dynamicToken: getDynamicToken},function(ret,err){ 
    			if(ret.status){
        			//alert(JSON.stringify(ret));
    			}else{
        			//alert(err.code);
    			}
	});
}

// **************************************************kc_添加《验证码》分享短信和微信 结束部分********************************************//


var deviceIsIos7 = function(){
	var isIos7 = false;
	if(typeof(api) == "undefined")
		return false;
    var systemType = api.systemType;
    if (systemType == 'ios') {
		setBaseInfo("isIos",true);
        var strSV = api.systemVersion;
        var numSV = parseInt(strSV,10);
        var fullScreen = api.fullScreen;
        var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
        if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
        	isIos7 = true;
			setBaseInfo("isIos7",true);
        }
	}
	return isIos7;
}


//系统基本信息设置
function setBaseInfo(k,v){
	if(k && v){
		var bs = $api.getStorage("base") || {};
		bs[k] = v;
		$api.setStorage("base",bs);
	}
}

//系统基本信息获取 city,weather,geo
function getBaseInfo(k){
	var bs = $api.getStorage("base") || {};
	return bs[k];
}
var deviceOpenGuide = function(){
	var p = {};
	if(typeof(api) == "undefined")
		return false;
	console.log("Open GUIDER!");
    api.openWin({
        name: 'GUIDE',
        url: "page/frame/guide.html",
        pageParam:p,
        animation:{type:"none"},
        bounces: false
    });
}

var deviceOpenFrame = function(url,title){
	var p = {url:url,title:title};
	if(typeof(api) == "undefined")
		return false;
    api.openWin({
        name: 'COMM',
        url: "page/frame/comm.html",
        pageParam:p,
        bounces: false
    });
}

var deviceOpenAdvert = function(advUrl,tm){
	if(firstUseApp()){
		console.log("don't open advert becase guiding now!");
		return;
	}
	console.log("open advert:",advUrl);
	var p = {url:advUrl};
	if(tm)
		p.timeout = tm;
	if(typeof(api) == "undefined")
		return false;
    api.openWin({
        name: 'ADVERT',
        url: "page/frame/advert.html",
        pageParam:p,
        bounces: false
    });
}

//imageBrowser
var deviceImageBrowser = function(imgList){
	var list = [];
	if(typeof(imgList[0]) != 'string'){
		//不是string则是dom
		var tagName = $(imgList[0]).attr("tagName");
		tagName = tagName.toUpperCase();
		for(var i = 0 ; i < imgList.length ; i++){
			var d = imgList[i];
			if(tagName == "IMG"){
				var s = $(d).attr("src");
				if(s)
					list.push(s);
			}
			else{
				var u = $(d).css("background-image");
				u = u.substr(4);
				u = u.substr(0,u.length-1);
				if(u)
					list.push(u);
			}
		}
	}
	else list = imgList;
	//console.log("show IMGS:",list);
	if(!list || list.length ==0) return;

	if(typeof(api) == "undefined")
		return false;
	var obj = api.require('imageBrowser');
	obj.openImages({
	    imageUrls: list,
	    showList:true
	});
}

var deviceSelectTime = function(dateortime,dft,cb){
	var t = dateortime?'date':'time';
	var tt = dateortime?'选择日期':'选择时间';
	if(typeof(api) == "undefined")
		return false;
		console.log("deviceSelectTime open",t,tt,dft);
	api.openPicker({
	    type: t,
	    date: dft,
	    title:tt
	},function(ret,err){
		console.log("deviceSelectTime,",ret,err);
	    cb(ret);
	});
}

var deviceOpenAlbum = function(imgList){
	deviceImageBrowser(imgList);
	if(true)return;
	/*$api.setStorage('PicAlbum',imgList);
	            console.log('deviceOpenAlbum0');
	if(typeof(api) == "undefined")
		return false;
	            console.log('deviceOpenAlbum1');
	api.openFrame({
	    name: 'PicAlbum',
	    url: 'page/frame/album.html',
	    rect:{
	        x:0,
	        y:0,
	        w:'auto',
	        h:'auto'
	    },
	    bounces: true,
	    bgColor: '0'
	});
	            console.log('deviceOpenAlbum2');*/
}

//获取照片
var deviceGetPicture = function(opt,okf,errf,allowEdit){
	function _deGet(pt){
		if(typeof(api) == "undefined")
			return false;
		api.getPicture(pt, function(ret, err){ 
		    if (ret && ret.data) {
		    	//console.log('GET PIC OK!',ret.data);
		    	if(okf)
		        	okf(ret);
		    } else{
		        if(errf)
		        	errf(err);
		    }
		    setTimeout(function(){
				$('#CONTENT').css("pointer-events","");
		    },500)
		});
	}
	function menuClose(){
		$('#BACKDIV').html("");
		$('#BACKDIV').css('height','');
		$('.ui-actionsheet').removeClass('show');
	}
	if(!allowEdit) allowEdit = false;
	if(!opt){
		opt = {
			//library,camera,album
		    sourceType: 'library',
		    //encodingType: 'jpg',
		    mediaValue: 'pic',
		    destinationType: 'base64',
		    allowEdit: allowEdit,
		    quality: 50,
		    targetWidth:640,
		    targetHeight:640
		};
		var h = '<div class="ui-actionsheet"><div class="ui-actionsheet-cnt"> \
            <button id="_fromcamera" style="color:#FF6666">拍照</button> \
            <button id="_fromlibrary">相册</button> \
            <button id="_picCancel">取消</button></div></div>';
		$('#CONTENT').css("pointer-events","none");
        $('#BACKDIV').css('height',window.innerHeight+'px');
        $('#BACKDIV').html(h);
        $('#_fromcamera').tap(function(){
        	opt.sourceType = 'camera';
        	menuClose();
        	_deGet(opt);
        });
        $('#_fromlibrary').tap(function(){
        	opt.sourceType = 'library';
        	menuClose();
        	_deGet(opt);
        });
        $('#_picCancel').tap(function(){
			$('#CONTENT').css("pointer-events","");
			if(errf) errf({msg:"cancel"});
        	menuClose();
        });
        setTimeout(function(){
        	$('.ui-actionsheet').addClass('show');
        },10);
	}
	else{
		_deGet(opt);
	}
}

//经纬度获取
var deviceGetLocation = function (successFunc, errorFunc) {
	if(typeof(api) == "undefined")
		return false;
	try{
		//console.log('api location start');
	//var baiduLocation = api.require('baiduLocation');
	var isok = false;
	api.startLocation({
		    accuracy: '100m',
		    filter:1,
		    autoStop: true
		},
	    function(ret, err){
	    	api.stopLocation();
	        if(ret.status){
	            console.log("Location deviceGetLocation ",ret);
	            var lat = ret.latitude;
	            var lon = ret.longitude;
	            var time = ret.timestamp;
	            var pos = {lon:lon,lat:lat};
	            if(successFunc && !isok)
	            	successFunc(pos);
	        } else{
	            console.log(err.msg);
	            if(errorFunc && !isok)
	            	errorFunc(err);
	        }
	        isok = true;
	    }
	);
	var baiduMap = api.require('bMap');
	baiduMap.getLocation({
	    accuracy: '100m',
	    filter:1,
	    autoStop: true
	},function(ret, err){
	    var sta = ret.status;
	    var lat = ret.lat;
	    var lon = ret.lon;
	    var t = ret.timestamp;
	    if(sta){
	        var str = '经度：'+ lon +'<br>';
	        str += '纬度：'+ lat +'<br>';
	        str += '更新时间：'+ t +'<br>';
	        var pos = {lon:lon,lat:lat};
	        console.log("baiduMap deviceGetLocation ",str);
	        if(successFunc && !isok)
	            successFunc(pos);
	    } else{
            console.log(err.msg);
            if(errorFunc && !isok)
            	errorFunc(err);
	    }
	    isok = true;
	});
		
	}catch(err){
		console.log('api location err:' ,err);
	}
};

//根据经纬度查城市和附近
//http://apistore.baidu.com/apiworks/servicedetail/469.html
//demo:http://api.map.baidu.com/geocoder/v2/?ak=x6xOgddT7x4tlPNbPmSL636m&callback=renderReverse&location=32.03,118.46&output=json&pois=1

var deviceGetGeoNear = function (info,okf,errf){
	var c = getBaseInfo('geo');
	if(c){
		okf(c);
		return;
	}
	var u = 'http://api.map.baidu.com/geocoder/v2/?'
	u += 'ak='+BAIDU_AK;
	//纬度、经度
	u += '&location='+info.lat+','+info.lon;
	u += '&pois=1&output=json';
	u = encodeURI(u);
	if(typeof(api) == "undefined")
		return false;
	try{
	api.ajax({
		type:'GET',
		url:u,
		dataType: 'json'
		},
		function(data,err){
			if(data){
				var r = data.result;
				//console.log('deviceGetGeoNear:',r);
				if(r && r.addressComponent)
				{
					var cc = r.addressComponent.city;
					cc = $.trim(cc);
					if(!cc) {
						var innerErr = {msg:"未找到定位城市"};
						console.log(innerErr.msg);
						if(errf){
							errf(innerErr);
						}
						return;
					}
					//去掉“市”
					if(cc.substr(-1,1) == "市"){
						cc = cc.substr(0,cc.length-1);
					}
					setBaseInfo('city',cc);
					setBaseInfo('gpscity',cc);
					//console.log('CITY:',cc);
				}
				if(r && r.pois){
					//{addr: "南京市浦口区", cp: "NavInfo", direction: "西南", distance: "319", name: "楼子", poiType: "行政地标",…}
					console.log('deviceGetGeoNear find near positions!');
				}
				setBaseInfo("geo",r);
				if(okf) okf(r);
			}
			if(err){
				if(errf) errf(err);
				console.log('deviceGetGeoNear net error:',err);
			}
		}
	);
		
	}catch(err){
		console.log('api ajax err:' ,err);
	}
}
//城市选择
var deviceCityList = function(cb,ef){
	var gps = getBaseInfo("gpscity");
	if(gps){
		cb(gps);
		return;
	}
	if(typeof(api) == "undefined")
		return ef(false);
	function errf(err){
		console.log(err);
		ef(false);
	}
	function fok(ret){
		try{
			var cc = ret.addressComponent.city;
			//去掉“市”
			if(cc.substr(-1,1) == "市"){
				cc = cc.substr(0,cc.length-1);
			}
			if(cc && cb){
				cb(cc);
			}
		}
		catch(EE){
			if(ef){
				ef(false);
			}
		}
		console.log("deviceCityList CITY:",cc);
	}
	function fok2(info){
		console.log("deviceCityList - deviceGetLocation ok");
		deviceGetGeoNear(info,fok,errf);
	}
	deviceGetLocation(fok2,errf);
}

//天气接口：
var deviceWeather = function(okf,errf){
	var city = getBaseInfo('city');
	var weather = getBaseInfo('weather');
	var cd = (new Date).format("yyyy-MM-dd");
	//已经有了当天数据就直接返回
	if(weather && weather.date == cd && weather.city == city){
		okf(weather);
		return true;
	}
	if(city)
	{
		var w = new weatherService();
		function f(ret){
			if(ret)
				setBaseInfo('weather',ret);
			if(okf)
				okf(ret)
		}
		console.log("调用取天气接口:",city);
		w.getWeather(city,f,errf);
		return true;
	}
	return false;
}
//根据经纬度找小区：
//http://api.map.baidu.com/place/search?&query=%E6%88%BF%E4%BA%A7&location=31.982742599517,118.7907119496&radius=2000&output=json&key=37492c0ee6f924cb5e934fa08c6b1676


var deviceAndroidKeyConf = function(keybackfunc,keymenufunc){
	if(typeof(api) == "undefined")
		return;
	if(api.systemType == "ios")
		return;
	if(keybackfunc){
		api.addEventListener({
		    name:'keyback'
		},function(ret,err){
		    keybackfunc();
		});
	}
	if(keymenufunc){
		api.addEventListener({
		    name:'keymenu'
		},function(ret,err){
		    keymenufunc();
		});
	}
}

var wxPay;
var wxPayOpt;
var aliPayOpt;

var deviceWXPay = function(opt,okf,errf){
	//去微信支付
	if(typeof(api) == "undefined"){
		goResult({opt:opt,msg:"不支持支付"});
		return;
	}
	$api.rmStorage("wxresult");
	//console.log("WX OPT:",opt);
	wx_config(f);
	function f(){
		wxPay = api.require('wxPay');
		//alert(JSON.stringify(opt));
		wxPayOpt = opt;
		wxPay.pay(opt,function(r, err){
			console.log("WX RET:",r,"  ERR:",err);
			if(r && r.status){
				goResult({'opt':wxPayOpt,msg:""});
				okf();
			}
			else{
				var info = "支付失败";
				if(err){
					switch(err.code){
						case -2:
							info = "已取消支付";
							break;
						default: 
							info = err.msg?(info+":"+err.msg):("支付通道建立失败,错误码:"+err.code);
							break;
					}
				}
				goResult({'opt':wxPayOpt,msg:info});
				//alert(info);
				errf(info);
			}
		});
	}
	function goResult(obj){
    	obj.type = _devicePayWay.type;
    	obj.realJSON = wxPayOpt;
		$api.setStorage("wxresult",obj);
		switchPage("me/wxpayresult","me/biz");
		routers["me/biz"].back = "me";
	}
}

var deviceAliPay = function(opt,okf,errf){
    // var wxopt = {
    //     description : result.proName||result.proCode,
    //     totalFee : USEDEBUG?1:(parseInt(result.feeMoney)+parseInt(result.money))*100,
    //     tradeNo : ret.outtradeno,
    //     productId : ret.outtradeno
    // }
//  alert(JSON.stringify(opt));
    function wxopt2aliopt(obj){
        return {
            subject:obj.description,
            body:obj.description,
            amount:obj.totalFee/100,
            tradeNO:obj.tradeNo
        };
    }
    wxPayOpt = opt;
    aliPayOpt = wxopt2aliopt(opt);
    //去微信支付
    if(typeof(api) == "undefined"){
        goResult({opt:opt,msg:"不支持支付"});
        return;
    }
    $api.rmStorage("wxresult");
    alipay_config(f);
    function f(){
        var aliPay = api.require('aliPay');
        //alert(JSON.stringify(opt));
        aliPay.pay(aliPayOpt,function(r, err){
            console.log("ALIPAY RET:",r,"  ERR:",err);
            if(r && r.code == '9000'){
                goResult({'opt':wxPayOpt,msg:""});
                okf();
            }
            else{
                var info = "支付失败";
                if(r){
                    switch(r.code){
                        //4000：系统异常
                        case '4000':info="系统异常";break;
                        case '4001':info="数据格式不正确";break;
                        case '4003':info="该用户绑定的支付宝账户被冻结或不允许支付";break;
                        case '4004':info="该用户已解除绑定";break;
                        case '4005':info="绑定失败或没有绑定";break;
                        case '4006':info="订单支付失败";break;
                        case '4010':info="重新绑定账户";break;
                        case '6000':info="支付服务正在进行升级操作";break;
                        case '6001':info="用户中途取消支付操作";break;
                        case '0001':info="缺少商户配置信息（商户id，支付公钥，支付密钥）";break;
                        case '0002':info="缺少参数（subject、body、amount、tradeNO）";break;
                        case '0003':info="签名错误（公钥私钥错误）";break;
                        default:info = info + r.code;
                    }
                }
                goResult({'opt':wxPayOpt,msg:info});
                //alert(info);
                errf(info);
            }
        });
    }
    function goResult(obj){
    	obj.type = _devicePayWay.type;
    	obj.realJSON = aliPayOpt;
        $api.setStorage("wxresult",obj);
        switchPage("me/wxpayresult","me/biz");
        routers["me/biz"].back = "me";
    }
}

var _devicePayWay = {type:1,cb:null};

var _payTypeChoosed = function(type){
	_devicePayWay.type = type;
	if(_devicePayWay.cb){
		_devicePayWay.cb(type);
	}
	$('#PAYDLG').remove();
}

var _payTypeChoosedCancel = function(){
	$('#PAYDLG').remove();
	_devicePayWay.cb=null;
	goBack();
}

var deviceChoosePayWay = function(choosedBk,hd){
	_devicePayWay.type = 1;
	_devicePayWay.cb = choosedBk;
    // var info = '<button onclick="_payTypeChoosed(1)">微信支付</button>  ';
    // info += '<button onclick="_payTypeChoosed(2)">支付宝支付</button>  ';
    // info += '<button onclick="_payTypeChoosedCancel()">取消</button>  ';
    // var h = '<div class="ui-actionsheet" id="PAYDLG">  \
    //             <div class="ui-actionsheet-cnt"> \
    //                 <h4>请选择支付方式</h4> '+info+'</div>         \
    //         </div>'
    // $("body").append(h);
    if(hd)
    	hd.ios7 = deviceIsIos7();

	var tmpText = doT.template($("#payTempl").text());
	var h = hd?tmpText(hd):tmpText();
    $("body").append(h);

    setTimeout(function(){
    	if(hd){
    		if(hd.paytype>0)
    			_devicePayWay.type = hd.paytype;
    	}
        $('#PAYDLG').show(300);
        var doms = $("#PAYDLG .pay");
        if(_devicePayWay.type == 1){
        	$(doms[0]).prop("checked",true);
        }
        if(_devicePayWay.type == 2){
        	$(doms[1]).prop("checked",true);
        }
		doms.click(function () { 
			this.blur();   
			this.focus(); 
	    	// console.log(1,$(this).is(":checked"));
		}).change(function(ev){
			var that = this;
			var type = 0;
			$.each(doms,function(ix,d){
				if(d != that && $(d).is(":checked")){
					$(d).prop("checked",false);
					// $(d).removeAttr("checked");
				}
				if($(d).is(":checked")){
					type += ix+1;
				}
			})
	    	if(type == 0)
	    		$("#PAYDLG .ui-btn-danger").addClass("disabled");
	    	else
	    		$("#PAYDLG .ui-btn-danger").removeClass("disabled");
	    	_devicePayWay.type = type;
	    });
	    $("#PAYDLG .ui-btn-danger").click(function(){
	    	if(_devicePayWay.type==0){
	    		alert("请选择支付方式");
	    		return;
	    	}
			if(_devicePayWay.cb){
				_devicePayWay.cb(_devicePayWay.type);
			}
			$('#PAYDLG').remove();
	    });
    },100);
}

var devicePay = function(opt,okf,errf){
	if(_devicePayWay.type == 2){
		console.log("Use Ali Pay!",opt);
		deviceAliPay(opt,okf,errf);
	}
	else{
		console.log("Use WX Pay!",opt);
        deviceWXPay(opt,okf,errf);
	}
}