
Date.prototype.format = function(fmt)   
{ //author: meizz   
  var o = {   
    "M+" : this.getMonth()+1,                 //月份   
    "d+" : this.getDate(),                    //日   
    "h+" : this.getHours(),                   //小时   
    "m+" : this.getMinutes(),                 //分   
    "s+" : this.getSeconds(),                 //秒   
    "q+" : Math.floor((this.getMonth()+3)/3), //季度   
    "S"  : this.getMilliseconds()             //毫秒   
  };   
  if(/(y+)/.test(fmt))   
    fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));   
  for(var k in o)   
    if(new RegExp("("+ k +")").test(fmt))   
  fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));   
  return fmt;   
}
//,fullscreen:true -- no footer
var routers = {
	'home':               {title:'游客小区',iscoll:true,back:null,cache:null,param:null,styles:['./asset/css/home.css']},
	'home/lt':            {title:'小区论坛',iscoll:false,fullscreen:true, styles:['./asset/css/luntan.css','./asset/css/pulldownup.css']},
	'home/ft':            {title:'发布话题',iscoll:true, fullscreen:true, styles:['./asset/css/page.css','./asset/css/luntan.css']},
	'home/ltxq':		  {title:'话题详情',iscoll:true, fullscreen:true, styles:['./asset/css/page.css','./asset/css/luntan.css']},
	'home/hd':		      {title:'小区活动',iscoll:false,fullscreen:true, styles:['./asset/css/luntan.css','./asset/css/pulldownup.css']},
	'home/hdxq':	      {title:'活动详情',iscoll:true, fullscreen:true, styles:['./asset/css/page.css','./asset/css/luntan.css']},
	'home/hdfb':		  {title:'发布活动',iscoll:true, fullscreen:true, styles:['./asset/css/page.css','./asset/css/luntan.css']},
	'home/gg':		      {title:'小区公告',iscoll:false,fullscreen:true, styles:['./asset/css/luntan.css','./asset/css/pulldownup.css']},
	'home/ggxq':	      {title:'公告详情',iscoll:true, fullscreen:true, styles:['./asset/css/page.css','./asset/css/luntan.css']},
	'key':                {title:'家',      iscoll:false,fullscreen:false,styles:['./asset/css/page.css','./asset/css/pageMain.css']},
	'key/jyk':            {title:'加油卡',  iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'key/bx':             {title:'报修',    iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'key/bs':             {title:'报事',    iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'key/tsjy':           {title:'投诉建议',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'key/fktxz':          {title:'通行证',  iscoll:true,fullscreen:true, styles:['./asset/css/page.css']},
	'key/wyf':            {title:'缴物业费',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'key/tcf':            {title:'缴停车费',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'key/shjf':           {title:'生活缴费',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'key/tcjf':           {title:'停车缴费',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'key/jf/sf':          {title:'缴水费',  iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'key/jf/df':          {title:'缴电费',  iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'key/jf/rqf':         {title:'缴燃气费',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'key/jf/txf':         {title:'缴通信费',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'key/jf/sjcz':        {title:'手机充值',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'key/wxfk':           {title:'维修账单',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'key/wjzd':           {title:'未缴账单',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'service':            {title:'服务',    iscoll:false,fullscreen:false,styles:['./asset/css/page.css','./asset/css/pageMain.css']},
	'money':              {title:'理财',    iscoll:false,fullscreen:false,styles:['./asset/css/page.css','./asset/css/pageMain.css']},
	'me':                 {title:'我',      iscoll:false,fullscreen:false,styles:['./asset/css/page.css']},
	'me/biz':             {title:'我的事项',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'me/bspj':            {title:'我的报事',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'me/bxpj':            {title:'我的报修',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'me/tsjypj':          {title:'投诉建议',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'me/paylog':          {title:'订单详情',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'me/wxpayresult':     {title:'支付结果',iscoll:false,fullscreen:false,styles:['./asset/css/page.css']},
	'user/main':          {title:'用户中心',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'user/sign':          {title:'登录',    iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'user/register':      {title:'注册',    iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'user/forgot':        {title:'忘记密码',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'user/about':         {title:'关于',    iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'user/sign/jbxx':     {title:'账户信息',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'user/sign/yhxx':     {title:'用户信息',iscoll:false,fullscreen:true, styles:['./asset/css/page.css']},
	'user/sign/fwxx':     {title:'房屋详情',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'user/sign/fwlist':   {title:'房屋信息',iscoll:true, fullscreen:true, styles:['./asset/css/page.css']},
	'srv/wyfw':		      {title:'物业服务',iscoll:false,fullscreen:true, styles:['./asset/css/luntan.css','./asset/css/pulldownup.css']},
	'srv/wyfwxq':		  {title:'物业服务',iscoll:true,fullscreen:true, styles:['./asset/css/luntan.css','./asset/css/pulldownup.css']},
	'srv/fwzs':           {title:'房屋租售',iscoll:false,fullscreen:true, styles:['./asset/css/luntan.css','./asset/css/pulldownup.css']},
	'srv/fwfb':           {title:'房源发布',iscoll:true, fullscreen:true, styles:['./asset/css/luntan.css','./asset/css/page.css']},
	'srv/fwxq':           {title:'房源信息',iscoll:true, fullscreen:true, styles:['./asset/css/luntan.css','./asset/css/page.css']},
	'srv/zbsh':           {title:'周边商户',iscoll:true, fullscreen:true, styles:['./asset/css/luntan.css']}
};
routers.home.title = '<a style="max-width:200px;" class="ui-nowrap">'+switchRoom()+'</a>';
var STW = 320;
var currentRoute;
//加载完成后的方法调用
var pageready;
//缓存更新后的方法调用
var domready;
//移除页面后的方法调用
var pageremoved;
//退出提示
var pageconfirmremove;
//临时全局缓存
var TMPCACHE;
var iScoll;

function switchMainButton(dom,go){
	if($(dom).hasClass('unactive')){
		var zpts = $('.ui-footer li');
		zpts.removeClass('inactive');
		zpts.addClass('unactive');
		$(dom).addClass('inactive');
		var mainId = zpts.indexOf(dom);
		if(go)
		{
			var ru;
			switch(mainId){
				case 0:ru = "home";break;
				case 1:ru = "key";break;
				case 2:ru = "service";break;
				case 3:ru = "money";break;
				case 4:ru = "me";break;
			}
			if(getUserIdentity() == 0 && mainId>0){
				toastDlg("请先登录。没有账号请先注册");
				switchPage("user/sign");
				return;
			}
			if(ru != currentRoute){
				switchPage(ru);
				hideFrames();
			}
		}
	}
}

function useScoll(f,end){
	if(f === false)
	{
		if(iScoll){
			iScoll.scrollTo(0,0);
			iScoll.disable();
		}
		$('#CONTENT').removeClass('iScrollWapper');
	}
	else{
		iScoll = iScoll || new IScroll('#CONTENT',{scrollbars: false});
		$('#CONTENT').addClass('iScrollWapper');
		iScoll.enable();
		//有些机器性能不行，只能推后
		function f() {
			if(!iScoll) return;
			iScoll.refresh();
			if(end === true)
				iScoll.scrollTo(0,iScoll.maxScrollY);
			else
				iScoll.scrollTo(0,0);
		}
		setTimeout(f, 800);
		f();
	}
	//console.log('use Scroll:',f);
}

function fitScreen(){
	var sw = window.innerWidth;
	$.each($('[fs]'),function(dx,it){
		var w = $(it).data("width");
		var h = $(it).data("height");
		var r = $(it).data("rate");
		var rt = sw/STW;
		if(r>0){
			rt = rt * r;
		}
		$(it).attr("width",w*rt);
		$(it).attr("height",h*rt);
	});
}

function hideFrames(){
	for(var dx in routers)
	{
		var rt = routers[dx];
		clearCache(rt);
	}
}

function clearCache(rt){
	delete rt.back;
	delete rt.cache;
	//delete rt.param;
}

function setParam(ps){
	var rt = routers[currentRoute];
	if(rt)
	{
		rt.param = ps;
	}
}

function getParam(){
	var rt = routers[currentRoute];
	if(rt && rt.back)
	{
		rt = routers[rt.back];
		return rt.param;
	}
	return null;
}

function goBack(){
	function _back(){
		//history.back();
		var rt = routers[currentRoute];
		function backEnd(){
			try{
				$('#CONTENT').removeClass("show");
				currentRoute = null;
				if(pageremoved)
					pageremoved();
				pageremoved = null;
				pageconfirmremove = null;
				domready = null;
				switchPage(rt.back);
				clearCache(rt);
			}catch(er){
				switchPage("home")
			}
		}
		if(pageconfirmremove)
		{
		    var dia=$.dialog({
		        content:pageconfirmremove,
		        button:["确认","取消"]
		    });

		    dia.on("dialog:action",function(e){
		        if(e.index == 0){
		        	backEnd();
		        }
		    });
		    dia.on("dialog:hide",function(e){
		        //console.log("dialog hide")
		    });
		    return;
		}
		backEnd();
	}
	//只有IOS有键盘问题
	if(keyboardState != "closed" && !isIos){
		$("#CONTENT input").blur();
		$("#CONTENT textarea").blur();
		$(document).one("keyboardClosed",function(){
			_back();
		})
	}
	else _back();
}

function switchPage(tag,bk) {
	if(getUserIdentity()<2){
		if(tag == "key/bs" || tag == "key/bx" || tag == "key/tsjy" || tag == "key/fktxz"){
			toastDlg("只有已验证的社区用户才能使用!");
			switchPage("user/main");
			return;
		}
	}
	function realfunc(){
		var found = false;
		for (var n in routers) {
			if (tag == n) {
				found = true;
				break;
			}
		}
		if (!found) {
			console.log("TAG NOT FOUND:",tag,bk);
			tag = 'home';
		}
		var doms;
		if (currentRoute) {
			var oldrouter = routers[currentRoute] || (routers[currentRoute] = {});
			var newrouter = routers[tag] || (routers[tag] = {});
			if (true) {
				routers[currentRoute].cache = $('#scroller').children();
			}
			routers[tag].back = bk?bk:currentRoute;
		} else {
			doms = routers[tag].cache;
		}
		if (tag)
			currentRoute = tag;
		var crRt = routers[tag];
		var url = currentRoute;
		if (url.indexOf(".html") != url.length - 6 || url.length <= 5) {
			url = url + ".html";
		}
		if(tag == "home"){
			$("#ROOMLIST").show();
			crRt.title = '<a style="max-width:200px;" class="ui-nowrap">'+switchRoom()+'</a>';
		}
		else
			$("#ROOMLIST").hide();
		pageready = null;
		pageremoved = null;
		if (url.indexOf('/') > 0)
			$('#BACK').show();
		else
			$('#BACK').hide();
		//$('#BAR_RIGHT').children().hide();
		var ulist = currentRoute.split('/');
		if (currentRoute == "home") {
			$('#USER').show();
			$('#CITYBAR').show();
		} else {
			$('#USER').hide();
			$('#CITYBAR').hide();
		}
		switch (ulist[0]) {
			case 'home':
				switchMainButton($('.ui-footer li')[0], false);
				break;
			case 'key':
				switchMainButton($('.ui-footer li')[1], false);
				break;
			case 'service':
				switchMainButton($('.ui-footer li')[2], false);
				break;
			case 'money':
				switchMainButton($('.ui-footer li')[3], false);
				break;
			case 'me':
				switchMainButton($('.ui-footer li')[4], false);
				break;
		}
		$('#CONTENT').removeClass("show");

		$('link[autostyle]').remove();
		var styles = crRt.styles;
		if(styles != undefined && styles != null && styles.length > 0){
			for(var i=0;i<styles.length;i++){
				$('head').append('<link rel="stylesheet" type="text/css" href="' + styles[i] + '" autostyle/>');
			}
		}
		//$('#CONTENT').removeClass("animated ");
		//$('#CONTENT').removeClass("fadeInRight");

		$('#scroller').children().remove();
		if (doms) {
			$('#scroller').append(doms);
			if (domready)
				domready();
			if(typeof(api) != "undefined")
				api.parseTapmode();
			setTimeout(function(){
				$('#CONTENT').addClass("show");
				//$('#CONTENT').addClass("animated ");
				//$('#CONTENT').addClass("fadeInRight");
			},10);
		} else {
			//console.log('load :',url);
			$('#scroller').load("./page/" + url, function() {
				try {
					if (pageready) pageready();
					$("#CONTENT input").attr("tapmode","true");
					$("#CONTENT textarea").attr("tapmode","true");
					$("#CONTENT button").attr("tapmode","true");
					if(typeof(api) != "undefined")
						api.parseTapmode();
				} catch (ER) {
					console.log(ER);
				}
				$('#CONTENT').addClass("show");
				if(tag != "user/sign"){
					//$('#CONTENT').addClass("animated ");
					//$('#CONTENT').addClass("fadeInRight");
				}
			});
		}
		fixedWinSize();
	}

	//只有IOS有键盘问题
	if(keyboardState != "closed" && !isIos){
		$("#CONTENT input").blur();
		$("#CONTENT textarea").blur();
		$(document).one("keyboardClosed",function(){
			realfunc();
		})
	}
	else realfunc();
}

//修复窗口尺寸属性
function fixedWinSize(){
	$('body').css("width","100%");
	$('body').css("height",window.innerHeight+"px");
	$('html').css("height",window.innerHeight+"px");
	var contentH = window.innerHeight - getBarH();
    $('#CONTENT').css('height',contentH+"px");
    $('#CONTENT').css('border-bottom',"0");
    $('#CONTENT').css('border-bottom',"0");
	crRt = routers[currentRoute];
	if(crRt)
	{
		//console.log("RT:",crRt);
		if(crRt.fullscreen){
			$('#FOOTER').hide();
			$('#CONTENT').css("padding-bottom","56px");
		}
		else{
			$('#FOOTER').show();
			$('#CONTENT').css("padding-bottom","");
		}
		if(crRt.title)
			$('#TITLE').html(crRt.title);
		if(crRt.iscoll){
			$('#scroller').css('min-height',(contentH+1)+"px");
			$('#scroller').css('max-height',"");
		}
		else{
			$('#scroller').css('min-height','');
			$('#scroller').css('max-height',(contentH-1)+"px");
		}
		useScoll(crRt.iscoll);
	}
	else{
		console.log("NO CURRENT ROUNT!");
	}
	$(window).scrollTop();
}

function getBarH(){
	if(isIos7)
		return 45+56+20;
	else
		return 45+56;
}

cityChanged = function(city){
	city = $.trim(city);
	console.log("Switch City:",city);
	if(city){
		setBaseInfo("city",city);
		$('#CITYNAME').text(city);
		if(!weatherCkFunc){
			deviceWeather();
			return;
		}
		function errfunc(d){
			console.log("GET weather ERROR:",d);
		}
		deviceWeather(weatherCkFunc,errfunc);
	}
}

function goUserPage(){
	var u = $api.getStorage("user");
    if(!u || !u.userphone || !u.logon)
        switchPage("user/sign");
    else
		switchPage("user/main");
}

var isIos = false;
var isIos7 = false;
var _inited = false;
var openCityList = $.noop;
var _tempScroll;
var init = function(){
	if(_inited) return;
	_inited = true;
	$('#BACK').tap(function(e){
		goBack();
	});
	$('.ui-footer li').tap(function(e){
		switchMainButton(this,true);
	});
	$('#USER').tap(goUserPage);
	$('#CITYBAR').tap(function(){
		openCityList();
	});
    $("#TITLE").click(function(){
    	if(currentRoute!="home")
    		return;
        var u = $api.getStorage("user");
        if(!u || !u.currentroom){
            return;
        }
        var listinfo = "";
        var validroomNumber = 0;
        _.each(u.roomlist,function(ix){
            if(ix.status==2){
                listinfo += '<button onclick="switchRoom('+ix.registid+')">'+ix.areaname+"-"+ix.buildno+"-"+ix.roomno+'</button>  ';
                // for(var ii = 0 ; ii < 2 ; ii++){
                // 	listinfo += '<button onclick="switchRoom('+ix.registid+')">'+ix.areaname+"-"+ix.buildno+"-"+ix.roomno+'</button>  ';
                // }
                validroomNumber++;
            }
        })
        if(validroomNumber <= 1) return;
        listinfo += '<button onclick="$(\'#ROOMLIST\').remove()">取消</button>  '
        var ix = u.currentroom;
        var h = '<div class="ui-actionsheet" id="ROOMLIST">  \
                    <div class="ui-actionsheet-cnt"> \
                        <h4>当前所选房屋：'+ix.areaname+"-"+ix.buildno+"-"+ix.roomno+'</h4> '+listinfo+'</div>         \
                </div>'
        $("body").append(h);
        setTimeout(function(){
        	var fs = $('#ROOMLIST>div').offset();
        	//console.log(fs.height);
        	if(fs.height > window.innerHeight){
        		if(_tempScroll){
        			_tempScroll.disable();
        			_tempScroll = null;
        		}
        		_tempScroll = new IScroll('#ROOMLIST',{scrollbars: false});
        		$('#ROOMLIST>div').css("height",window.innerHeight).css("position","initial");
        	}
            $('#ROOMLIST').addClass('show');
        },100);
    });
    //初始化时，先使用缓存数据登录
	var u = $api.getStorage("user");
	function goLogin(){
		$("body").show();
		//showLoading();
		function loginend(ret){
			closeLoading();
			if(!ret || ret.msg){
				currentRoute = "user/sign";
				switchPage('user/sign','home');
				return;
			}
			currentRoute = "home";
		    switchPage('home');
		}
		//首次登录初始化该值
		if(u && u.logon){
			u.logon = false;
			$api.setStorage("user",u);
		}
		if(u && u.userphone)
	    	$.apiLogin(u.userphone,u.userpwd,loginend,loginend);
	    else
	    	loginend(false);
	}
	if(!firstUseApp()){
		goLogin();
	}
	else{
		deviceOpenGuide();
		setTimeout(function(){
			goLogin();
		},2000);
	}
};


var firstUseApp = function(){
	var v = $api.getStorage("innerverison");
	if(typeof(api) == "undefined")
		return false;
	return api.appVersion != v;
}

//0:游客,1:注册用户,2：认证业主
function getUserIdentity(){
	var cw = 0;
    var u = $api.getStorage("user")||{};
    if(u && u.logon  && u.userphone){
        cw = u.currentroom?2:1;
    }
    return cw;
}

function getWelcomeWord(color){
	var cw = "游客";
    var u = $api.getStorage("user")||{};
    var idt = getUserIdentity();
    cw = idt==0?cw:(idt==1?"注册用户":"小区业主");
    var d = new Date();
    var hr = d.getHours();
    var t = "";
    if(hr > 5 && hr < 12)
        t = '上午';
    else if(hr <= 17 && hr >= 12)
        t = '下午';
    else
        t = '晚上';
    return ('<li class="ui-col ui-col-100" style="background-color:'+color+';padding: 2px 10px;font-size: 14px;">尊敬的'
    		+cw+'<span style="color:blue">'+(u.nickname||"")+'</span>，'+t+'好！</li>');
}

function switchRoom(roomid){
	//console.log('ROOMID:',roomid);
	var u = $api.getStorage("user")||{};
	if(roomid && u.roomlist){
		if(u.currentroom && u.currentroom.registid == roomid){
			$("#ROOMLIST").remove();
			return;
		}
		u.currentroom = _.find(u.roomlist,function(it){return it.registid==roomid && it.status == 2;});
		if(!u.currentroom)
			return;
		u.areacode = u.currentroom.areacode;
		u.isAutoCheck = u.currentroom.checktype == 1;
		$api.setStorage("user",u);
		//通知服务端切换小区
		$.apiSwitchArea();
		if(typeof(HomefreshUI) != "undefined")
			HomefreshUI();
	}
	//console.log('ROOMLIST:',u.roomlist);
	u.currentroom = u.currentroom||{};
	var h = '<i class="icon iconfont" style="font-size:20px">&#xf014a;</i> '+(u.currentroom.areaname||"游客小区");
	$("#TITLE").html(h);
	$("#ROOMLIST").remove();
	return h;
}
//取天气信息更新方法
var weatherCkFunc;
apiready = function(){
	$("body").hide();
	setTimeout(function(){$("body").show();},5000);
	isIos7 = false;
				// isIos = isIos7 = true;
		  //   	$('#HEADER').addClass('ios7');
		  //   	$('#CONTENT').addClass('ios7');
		  //   	$('#BAR_RIGHT').addClass('ios7');
	if(typeof api != "undefined"){
	    var systemType = api.systemType;
	    if (systemType == 'ios') {
	    	isIos = true;
	        var strSV = api.systemVersion;
	        var numSV = parseInt(strSV,10);
	        var fullScreen = api.fullScreen;
	        var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
	        if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
	        	isIos7 = true;
		    	$('#HEADER').addClass('ios7');
		    	$('#CONTENT').addClass('ios7');
		    	$('#BAR_RIGHT').addClass('ios7');
	        }
		}
		deviceInit();
    }
	init();
	deviceAndroidKeyConf(function(){
		var winName = api.winName;
		if(winName != "root")
			return;
        closeLoading();
		if(currentRoute == 'home'){
			api.confirm({
			    title: '',
			    msg: '真的要退出吗？',
			    buttons:['确定', '取消']
			},function(ret,err){
			    if(ret.buttonIndex == 1){
		            api.closeWidget({
		                id: APPID,
		                retData: {name:'closeWidget'},
		                silent:true
		            });
			    }
			});
		}
		else
			goBack();
	},goUserPage);
	
	var gps = getBaseInfo("gpscity");
	if(gps)
		$('#CITYNAME').text(gps);

	function locMeOK(ret){
		var ct = getBaseInfo("city");
		console.log("LOCMEOK:",ct);
		cityChanged(ct);
	}
	function locMe(loc){
		console.log("GETMYLOC:",loc);
		deviceGetGeoNear(loc,locMeOK);
	}
    //取定位经纬度、查看当前的位置
	deviceGetLocation(locMe);
	//deviceGetGeoNear({lon:118.46,lat:32.03});
	//每次打开通知服务端。
	$.apiNotice();
}

$(function(){
	if(USEDEBUG)
    	apiready();
    //location.href="http://www.baidu.com"
    //setInterval(function(){console.log(GetRandom(4))},1000);
});