function mobileService() {

	function getMobileService(mobile,okf,errf){
		var APIKEY = BAIDUAPIKEY;
		if(typeof(api) == "undefined")
			return false;
		var u = 'http://apis.baidu.com/apistore/mobilephoneservice/mobilephone?tel='+mobile;
		api.ajax({
			headers:{apikey:APIKEY},
			type:'GET',
			url:u,
			dataType: 'json'
			},
			function(data,err){

				console.log("getMobileService info:",data);
				if(data){
					if(data.errNum==0){
						okf(data);
					}
					else{
						errf(data);
					}
				}
				if(err){
					if(errf) errf(err);
					console.log('getMobileService net error:',err);
				}
			}
		);
	}

	function getMobileCarrier(mobile,okf,errf){
		function sucf(ret){
			if(!ret.retData || !ret.retData.supplier){
				okf("Unknown");
				return;
			}
			var cr = ret.retData.supplier;
			if(cr.indexOf("移动")>=0)return "移动";
			if(cr.indexOf("联通")>=0)return "联通";
			if(cr.indexOf("电信")>=0)return "电信";
			return cr;
		}
		getMobileService(mobile,sucf,errf);
	}

	return {getMobileService:getMobileService,getMobileCarrier:getMobileCarrier};
}